*--------------------------------------------------------------------------*
*     User subroutine APSUB, meant for ex5-ex5c                            *
*                                                                          *
*     Mini-STAG VU-Amsterdam                                               *
*--------------------------------------------------------------------------*

      SUBROUTINE APSUB(NLIN,ILIN,IAP,ITYP,ITM,DATA,NP,IPIPE,FM,H,
     *                 P,T,X,W,C,RESULT,COMP,CONC,AVERG,IDX,NCOMP,
     *                 APNAME,NUMGEN,RDATGE)

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DOUBLE PRECISION DATA(50),FM(NP),H(NP,3),P(NP,3),T(NP,2),
     *                 X(NP,2),W(NP),C(NP),CONC(NLIN+7,NCOMP),
     *                 AVERG(NLIN+7),RDATGE(NUMGEN,6)
      INTEGER          IPIPE(NP),ILIN(NLIN),IDX(NCOMP)
      CHARACTER        COMP(NCOMP)*8,APNAME*12

      NAMELIST /CHP/ GTLOAD, HEATPR
      SAVE GTLOAD, HEATPR, FMAIR, LCOND, LIN, LOUT, HMAX, HMIN


*--------------------------------------------------------------------------*
*     Read namelist &CHP only in iteration number zero                     *
*--------------------------------------------------------------------------*

      IF (ITM.EQ.0) THEN

         REWIND 9
         READ(9,CHP,END=1)
    1    CONTINUE

*        Save air mass flow of apparatus 1
         IF (IAP.EQ.1) FMAIR=FM(1)

      ENDIF


*--------------------------------------------------------------------------*
*     Calculate fuel mass flow ( DELM <==> DATA(8) ) of source 16          *
*--------------------------------------------------------------------------*

      IF (IAP.EQ.16) THEN

         DATA(8)=-1.0*(0.007472484*GTLOAD+0.25267991)*0.3682923/FMAIR

*        Write results to standard message file
         WRITE(13,100) IAP
         WRITE(13,110) -1.0*DATA(8)*FMAIR

  110    FORMAT(' Current fuel mass flow is         ',F6.2,' kg/s')

      ENDIF


*--------------------------------------------------------------------------*
*     Equalize the deaerator outlet pressure ( POUT <==> DATA(2) )         *
*     to the saturation pressure at prevailing temperature                 *
*--------------------------------------------------------------------------*

      IF (IAP.EQ.53) THEN

*        Find internal number of deaerator outlet pipe
         IF (ITM.EQ.0) THEN
            DO 10 I=1,NP
               IF (ILIN(IPIPE(I)).EQ.69) LCOND=I
   10       CONTINUE
         ENDIF

*        Calculate saturation pressure
         IF (T(LCOND,1).GT.0.0) THEN
            PSAT   = PTXW(T(LCOND,1),X(LCOND,1),W(LCOND),C(LCOND),LCOND)
            DATA(2)= PSAT
         ELSE
            PSAT   = 0.2
            DATA(2)= PSAT
         ENDIF
    
*        Write results to standard message file
         WRITE(13,100) IAP
         WRITE(13,120) T(LCOND,1)
         WRITE(13,121) PSAT

  120    FORMAT(' Current condensate temperature is ',F6.2,' C')
  121    FORMAT(' Current saturation pressure is    ',F6.2,' bar')

      ENDIF


*--------------------------------------------------------------------------*
*     Calculate mass flow ( DELM <==> DATA(8) ) of source 101              *
*--------------------------------------------------------------------------*

      IF (IAP.EQ.101) THEN

         DATA(8)=-1.0*(HEATPR/(HMAX-HMIN))/FMAIR

*        Write results to standard message file
         WRITE(13,100) IAP
         WRITE(13,130) -1.0*DATA(8)*FMAIR

  130    FORMAT(' Current mass flow heating grid is ',F6.2,' kg/s')

      ENDIF

*--------------------------------------------------------------------------*
*     Calculate enthalpies at in- and outlet of apparatus 103              *
*--------------------------------------------------------------------------*

      IF ((IAP.EQ.103).AND.(ITM.LE.2)) THEN

*        Find internal number of in- en outletpipe of apparatus 103
         DO 20 I=1,NP
            IF (ILIN(IPIPE(I)).EQ.103) LIN=I
            IF (ILIN(IPIPE(I)).EQ.104) LOUT=I
   20    CONTINUE

         HMAX=H(LIN,2)
         HMIN=H(LOUT,1)

      ENDIF

  100 FORMAT(/ '  ----- Apparatus',I4,' -------------------------')

*--------------------------------------------------------------------------*
      END
*--------------------------------------------------------------------------*
